<?php
/**
 * LyftenBloggie 1.0 - Joomla! Blog Manager
 * @package 	LyftenBloggie 1.0
 * @subpackage 	Author Plugin 1.0
 *
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.lyften.com/ Official website
 **/
 
// Disallow direct access to this file
defined('_JEXEC') or die('Restricted access');

/**
 *	Returns a Authors
 */ 
function getauthors($plg_params){	

	global $mainframe;

	//include the needed helpers
	require_once (JPATH_SITE.DS.'components'.DS.'com_lyftenbloggie'.DS.'helpers'.DS.'route.php');
	require_once (JPATH_COMPONENT.DS.'helpers'.DS.'helper.php');
	
	$db 		=& JFactory::getDBO();
	$cparams 	= & $mainframe->getParams('com_lyftenbloggie');
	
	// get variables
	$limit = trim( $plg_params->get( 'maxAuthorsLimit') );
	
	$limit = ($limit)?' LIMIT '.$limit:'';
	
	// Get Authors
	if($cparams->get('authorLevel', 'LB') == 'LB')
	{
		$query = 'SELECT id, user_id, name' .	
			' FROM #__bloggies_authors' .			
			' WHERE published = 1' .			
			' ORDER BY id'
			. $limit
			;
		$db->setQuery($query);
		$authors = $db->loadObjectList();
	}else{
		$authorLevel = $cparams->get('authorLevel', 'LB');
		$query = 'SELECT DISTINCT created_by' .	
			' FROM #__bloggies_entries' .
			' ORDER BY created DESC'
			. $limit
			;
		$db->setQuery($query);
		$latest = $db->loadResultArray();
		$latest = implode( ',', $latest );

		$query = 'SELECT DISTINCT u.id as user_id, u.name' .	
			' FROM #__bloggies_entries AS e' .
			' LEFT JOIN #__users AS u ON u.id = e.created_by' .
			' WHERE u.block = 0' .
			' AND u.gid >= ' . $authorLevel .
			' AND e.created_by IN ('.$latest.')' .
			' ORDER BY u.id'
			;
		$db->setQuery($query);
		$authors = $db->loadObjectList();
	}	
	
	if(empty($authors)) return;
	
	$return = "<ul class=\"sideitem_list\">\n";
	foreach( $authors as $author)
	{
		$link			= LyftenBloggieHelperRoute::getAuthorEntriesRoute($author->user_id);
		$count			= plug_getCountEntries( $author->user_id );
		$author->name	= (!$author->name) ? plug_getAuthorName( $author->user_id ) : $author->name;
		
		$return .= "<li>\n";
		$return .= "	<span>\n";
		$return .= "		<a href=\"".$link."\">".$author->name." (".$count.")</a>\n";
		$return .= "	</span>\n";
		$return .= "</li>\n";
	}
	$return .= "</ul>\n";

	return $return;
}

function plug_getCountEntries($uid=0)
{
	$db	=& JFactory::getDBO();
		
	// Get Count of entries for author
	$query = 'SELECT COUNT(id)' .	
		' FROM #__bloggies_entries' .			
		' WHERE `created_by` = ' . (int)$uid;
	$db->setQuery($query);
	return ($count = $db->loadResult())?$count:0;
}

function plug_getAuthorName($uid=0)
{
	$db	=& JFactory::getDBO();
	$db->setQuery("SELECT name FROM #__users WHERE id='$uid'");
	return $db->loadResult();
}
