<?php
/**
 * LyftenBloggie 1.0 - Joomla! Blog Manager
 * @package LyftenBloggie 1.0
 * @copyright (C) 2009 Lyften Designs
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.lyften.com/ Official website
 **/
 
// Disallow direct access to this file
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

/**
 * @package Joomla
 * @subpackage LyftenBloggie
 * @since 1.0
 */
class LyftenBloggieControllerSideitems extends LyftenBloggieController
{
	/**
	 * Constructor
	 **/
	function __construct()
	{
		parent::__construct();

		// Register Extra task
		$this->registerTask( 'add'  ,		 	'edit' );
		$this->registerTask( 'apply', 			'save' );
		$this->registerTask( 'orderup'   , 		'order' );
		$this->registerTask( 'orderdown' , 		'order' );
	}

	/**
	 * Logic to upload a plugin
	 **/
	function doinstall()
	{
		require_once(JPATH_COMPONENT.DS.'libraries'.DS.'installer.php');
		$class 	= new LBInstaller();
		$msg 	= JText::_('PLUGIN INSTALL WAS SUCCESSFULL');
		
		$class->setPackage();
		
		if(!$class->check()) {
			$msg = $class->getError();
		}
	
		if(!$class->install()) {
			$msg = $class->getError();
		}

		$this->setRedirect('index.php?option=com_lyftenbloggie&view=sideitems', $msg);
	}

	/**
	 * Logic to save a sideitem
	 **/
	function save()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$task		= JRequest::getVar('task');

		//Sanitize
		$post 					= JRequest::get( 'post' );
		$post['html'] 			= JRequest::getVar( 'html', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$post['custom_title'] 	= JRequest::getVar( 'custom_title', '', 'post', 'string', JREQUEST_ALLOWRAW );

		$model = $this->getModel('sideitem');

		if ( $model->store($post) ) {

			switch ($task)
			{
				case 'apply' :
					$link = 'index.php?option=com_lyftenbloggie&view=sideitem&cid[]='.(int) $model->get('id');
					break;

				default :
					$link = 'index.php?option=com_lyftenbloggie&view=sideitems';
					break;
			}
			$msg = JText::_( 'SIDE ITEM SAVED' );
			
			$cache = &JFactory::getCache('com_lyftenbloggie');
			$cache->clean();

		} else {

			$msg 	= JText::_( 'Error Saving Side Item' );
			//JError::raiseError( 500, $model->getError() );
			$link 	= 'index.php?option=com_lyftenbloggie&view=sideitem';
		}

		$this->setRedirect($link, $msg);
	}

	/**
	 * Logic to publish sideitems
	 **/
	function publish()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$cid 	= JRequest::getVar( 'cid', array(0), 'post', 'array' );

		if (!is_array( $cid ) || count( $cid ) < 1) {
			$msg = '';
			JError::raiseWarning(500, JText::_( 'SELECT ITEM PUBLISH' ) );
		} else {

			$model = $this->getModel('sideitems');

			if(!$model->publish($cid, 1)) {
				JError::raiseError(500, $model->getError());
			}

			$msg 	= JText::_( 'SIDE ITEM PUBLISHED');
		
			$cache = &JFactory::getCache('com_lyftenbloggie');
			$cache->clean();
		}

		$this->setRedirect( 'index.php?option=com_lyftenbloggie&view=sideitems', $msg );
	}

	/**
	 * Logic to unpublish sideitems
	 **/
	function unpublish()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$cid 	= JRequest::getVar( 'cid', array(0), 'post', 'array' );

		if (!is_array( $cid ) || count( $cid ) < 1) {
			$msg = '';
			JError::raiseWarning(500, JText::_( 'SELECT ITEM UNPUBLISH' ) );
		} else {

			$model = $this->getModel('sideitems');

			if(!$model->publish($cid, 0)) {
				JError::raiseError(500, $model->getError());
			}

			$msg 	= JText::_( 'SIDE ITEM UNPUBLISHED');
		
			$cache = &JFactory::getCache('com_lyftenbloggie');
			$cache->clean();
		}
		
		$this->setRedirect( 'index.php?option=com_lyftenbloggie&view=sideitems', $msg );
	}

	/**
	 * Logic to delete sideitems
	 **/
	function remove()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );

		if (!is_array( $cid ) || count( $cid ) < 1) {
			$msg = '';
			JError::raiseWarning(500, JText::_( 'SELECT ITEM DELETE' ) );
		} else {

			$model = $this->getModel('sideitems');

			if(!$msg = $model->delete($cid)) {
				$msg = $model->getError();
			}

			$cache = &JFactory::getCache('com_lyftenbloggie');
			$cache->clean();
		}
		
		$this->setRedirect( 'index.php?option=com_lyftenbloggie&view=sideitems', $msg );
	}

	/**
	 * logic for cancel an action
	 **/
	function cancel()
	{
		$this->setRedirect( 'index.php?option=com_lyftenbloggie&view=sideitems' );
	}

	/**
	 * Logic to create the view for the edit sideitemscreen
	 **/
	function edit()
	{	
		JRequest::setVar( 'view', 'sideitem' );
		JRequest::setVar( 'hidemainmenu', 1 );

		parent::display();
	}
	
	/**
	 * Logic to order a sideitem
	 **/
	function order(  )
	{

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$db 		=& JFactory::getDBO();
		$params 	= & JComponentHelper::getParams('com_lyftenbloggie');
		$cid 		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		JArrayHelper::toInteger($cid, array(0));

		$uid    = $cid[0];
		$inc    = ( $this->getTask() == 'orderup' ? -1 : 1 );
		$row 	=& JTable::getInstance('sideitems', 'Table');
		$row->load( $uid );
		$row->move( $inc, 'ordering > -10000 AND ordering < 10000' );

		$this->setRedirect( 'index.php?option=com_lyftenbloggie&view=sideitems');
	}

	/**
	 * Logic to mass ordering sideitems
	 **/
	function saveorder( )
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$cid 	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		JArrayHelper::toInteger($cid, array(0));

		$db			=& JFactory::getDBO();
		$total		= count( $cid );
		$order 		= JRequest::getVar( 'order', array(0), 'post', 'array' );
		JArrayHelper::toInteger($order, array(0));

		$cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		JArrayHelper::toInteger($cid, array(0));
		
		$row 		=& JTable::getInstance('sideitems', 'Table');
		$conditions = array();

		// update ordering values
		for ( $i=0; $i < $total; $i++ )
		{
			$row->load( (int) $cid[$i] );
			if ($row->ordering != $order[$i])
			{
				$row->ordering = $order[$i];
				if (!$row->store()) {
					JError::raiseError(500, $db->getErrorMsg() );
				}
				// remember to updateOrder this group
				$condition = 'ordering > -10000 AND ordering < 10000';
				$found = false;
				foreach ( $conditions as $cond )
				{
					if ($cond[1]==$condition) {
						$found = true;
						break;
					}
				}
				if (!$found) $conditions[] = array($row->id, $condition);
			}
		}

		// execute updateOrder for each group
		foreach ( $conditions as $cond ) {
			$row->load( $cond[0] );
			$row->reorder( $cond[1] );
		}

		$msg 	= JText::_( 'NEW ORDERING SAVED' );
		$this->setRedirect( 'index.php?option=com_lyftenbloggie&view=sideitems', $msg );
	}
}