<?php
/**
 * LyftenBloggie 1.0 - Joomla! Blog Manager
 * @package LyftenBloggie 1.0
 * @copyright (C) 2009 Lyften Designs
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.lyften.com/ Official website
 **/
 
// Disallow direct access to this file
defined('_JEXEC') or die('Restricted access');

class EntriesHelper
{
	function getAuthor($userID=null)
	{
		global $mainframe;

		// Initialize variables
		$db 			= & JFactory::getDBO();
		$user			=& JFactory::getUser($userID);
		$params			=& $mainframe->getParams('com_lyftenbloggie');
		$authorLevel	= $params->get('authorLevel', 'LB');
		$adminLevel		= $params->get('adminLevel', 'LB');
		$allowed		= new stdClass();
		$allowed->admin	= false;

		//Find out if user is an Admin
		if(!$userID && $adminLevel != 'LB' && $adminLevel <=  $user->get('gid'))
		{
			$allowed->user_id 		= ($user->get('id')) ? $user->get('id') : 'no';
			$allowed->username 		= $user->get('name');
			$allowed->admin		 	= true;
			$allowed->permission 	= true;
			$allowed->allowpub	 	= true;
			$allowed->allowdelete 	= true;
			$allowed->avatar		= LDHTML::genAvatarURL($allowed->user_id, $params->get('avatarUsed', '0') );
			$allowed->attribs 		= '';
			return $allowed;
		}

		//Get Author/Admin Settings for user
		if($authorLevel == 'LB')
		{
			//Check to see if the user is allowed to post
			$query = 'SELECT user_id, permission, attribs'
					.' FROM #__bloggies_authors'
					.' WHERE user_id = '.$user->get('id')
					.' AND published = 1';
			$db->setQuery($query);
			if($allowed = $db->loadObject())
			{
				//Get permission
				$permission 			= new JParameter( $allowed->permission );
				$allowed->username 		= $user->get('name');
				$allowed->admin		 	= $permission->get('admin', 0);
				$allowed->avatar		= LDHTML::genAvatarURL($allowed->user_id, $params->get('avatarUsed', '0') );
				$allowed->permission 	= true;
				$allowed->allowpub	 	= $permission->get('allowpub', 1);
				$allowed->allowdelete 	= $permission->get('allowdelete', 1);
				$allowed->attribs 		= '';
			}else{
				$allowed->user_id 		= 'no';
				$allowed->username 		= $user->get('name');
				$allowed->admin		 	= false;
				$allowed->permission 	= false;
				$allowed->allowpub	 	= false;
				$allowed->allowdelete 	= false;
				$allowed->avatar		= LDHTML::genAvatarURL($allowed->user_id, 'none' );
				$allowed->attribs 		= '';
			}
			if(!$allowed->username) $allowed->username = $user->get('name');
		}else{
			$allowed->user_id 		= ($user->get('id')) ? $user->get('id') : 'no';
			$allowed->username 		= $user->get('name');
			$allowed->avatar		= LDHTML::genAvatarURL($allowed->user_id, $params->get('avatarUsed', '0') );
			$allowed->attribs 		= '';
			
			//What can the author do
			if($authorLevel <=  $user->get('gid')){
				$allowed->permission 	= true;
				$allowed->allowpub 		= $params->get('authorPub');
				$allowed->allowdelete 	= $params->get('authorDel');
			}else{
				$allowed->permission 	= false;
				$allowed->allowpub	 	= false;
				$allowed->allowdelete 	= false;
			}
		}
		
		return $allowed;
	}

	/**
	 * Returns the author   
	 **/ 
	function getAuthors($uid) {
		$database = & JFactory::getDBO();
		$database->setQuery("SELECT name FROM #__bloggies_authors WHERE user_id='$uid'");
		$result = $database->loadResult();		
		
		if(!$result){
			$database->setQuery("SELECT name FROM #__users WHERE id='$uid'");
			$result = $database->loadResult();
		}
		return $result;
	}	
	
	function saveEntryPrep( &$row )
	{
		// Get submitted text from the request variables
		$text = JRequest::getVar( 'text', '', 'post', 'string', JREQUEST_ALLOWRAW );

		// Clean text for xhtml transitional compliance
		$text		= str_replace( '<br>', '<br />', $text );

		// Search for the {readmore} tag and split the text up accordingly.
		$tagPos	= JString::strpos( $text, '<hr id="system-readmore" />' );

		if ( $tagPos === false )
		{
			$row->introtext	= $text;
		} else
		{
			$row->introtext	= JString::substr($text, 0, $tagPos);
			$row->fulltext	= JString::substr($text, $tagPos + 27 );
		}

		// Filter settings
		jimport( 'joomla.application.component.helper' );
		$config	= JComponentHelper::getParams( 'com_content' );
		$user	= &JFactory::getUser();
		$gid	= $user->get( 'gid' );

		$filterGroups	= (array) $config->get( 'filter_groups' );
		if (in_array( $gid, $filterGroups ))
		{
			$filterType		= $config->get( 'filter_type' );
			$filterTags		= preg_split( '#[,\s]+#', trim( $config->get( 'filter_tags' ) ) );
			$filterAttrs	= preg_split( '#[,\s]+#', trim( $config->get( 'filter_attritbutes' ) ) );
			switch ($filterType)
			{
				case 'NH':
					$filter	= new JFilterInput();
					break;
				case 'WL':
					$filter	= new JFilterInput( $filterTags, $filterAttrs, 0, 0 );
					break;
				case 'BL':
				default:
					$filter	= new JFilterInput( $filterTags, $filterAttrs, 1, 1 );
					break;
			}
			$row->introtext	= $filter->clean( $row->introtext );
			$row->fulltext	= $filter->clean( $row->fulltext );
		}

		return true;
	}
	
	/**
	 * Returns the permalink-URL for entry
	 **/ 
	function getPermalink($title, $id)
	{
		$database = & JFactory::getDBO(); 
	
		// Create permlink for entry		
		$link = EntriesHelper::_makeLink(trim($title)) . ".html";
		$link = preg_replace('/[!@#$%\^&*\(\)\+=\{\}\[\]|\\<">,\\/\^\*;:\?\'\\\]/', "", $link);

		$database->setQuery("SELECT * from #__bloggies_permalinks WHERE permalink='$link' and entryid!='$id'");
		$linkExists = $database->loadResult();
	
		if ($linkExists) {
			$link = EntriesHelper::_makeLink(trim($title));
			$plink = "$link-$uid.html";
			$database->setQuery("SELECT entryid from #__bloggies_permalinks WHERE permalink='$plink' and entryid!='$id'");
			$count = 0;
			while ($database->loadResult()) {
				$count++;
				$plink = "$link-{$id}-$count.html";
				$database->setQuery("SELECT entryid from #__bloggies_permalinks WHERE permalink='$plink' and entryid!='$id'");
			}
			$database->setQuery("INSERT INTO #__bloggies_permalinks SET permalink='$plink',entryid='$id'");
			if(!$database->query()){
				$results['msg'] = $database->getErrorMsg();	
			}
		} else {
			$database->setQuery("INSERT INTO #__bloggies_permalinks SET permalink='$link',entryid='$id'");
			if(!$database->query()){
				$results['msg'] = $database->getErrorMsg();	
			}
			$plink = $link;
		}

		return $plink;

	}
	
	/**
	 * Returns the SEF URL
	 **/ 
	function getSEFLink($url='')
	{
		global $mainframe;
		
		if(!$url) return;
		
		$uri 		=& JURI::getInstance();
		$baseURL 	= $uri->toString( array('scheme', 'host', 'port')).'/';
		
        // Do not run plugin if SEF is disabled
        $config =& JFactory::getConfig();
        if ($config->getValue('sef'))
		{
			// check if joomsef is enabled
			$path = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_sef'.DS.'classes'.DS.'config.php';
			if(file_exists($path)) {
				require_once( $path );
				require_once( JPATH_ROOT.DS.'components'.DS.'com_sef'.DS.'sef.router.php' );
				$sefConfig =& SEFConfig::getConfig();
				if ($sefConfig->enabled) {
					$router = new JRouterJoomsef();
					$newurl	= $router->build($url);
					$url 	= $newurl->_uri;
				}else{
					$router = JSite::getRouter();
					$newurl	= $router->build($url);
					$url 	= $baseURL.trim($newurl->_path, '/');
					if($mainframe->isAdmin()) {
						$url 	= str_replace( '/administrator', '', $url );
					}
				}
			}else{
				$router = JSite::getRouter();
				$newurl	= $router->build($url);
				$url 	= $baseURL.trim($newurl->_path, '/');
				if($mainframe->isAdmin()) {
					$url 	= str_replace( '/administrator', '', $url );
				}
			}
		}

		return $url;
	}
	
	/**
	 *	Get a list of categories for a content.
	 */ 
	function getCatLinks($id, $linkCats = true) {

		$database = & JFactory::getDBO();
		
		$query = 'SELECT id, title, slug'
				.' FROM #__bloggies_categories'
				.' WHERE id = ' . $id
				;
		$database->setQuery($query);
		$cat 	= $database->loadObject();
		if ($cat) {
			if ($linkCats) {
				$link = '<a href="'.JRoute::_(LyftenBloggieHelperRoute::getCategoryRoute($cat->slug)).'" title="View all posts in '.$cat->title.'" rel="category">'.$cat->title.'</a>';				
			} else {
				$link = $cat->name;
			}
		} else {
				$link = '<a href="'.JRoute::_(LyftenBloggieHelperRoute::getCategoryRoute(JText::_('UNCATEGORIZED'))).'" title="View all posts in '.JText::_('UNCATEGORIZED').'" rel="category">'.JText::_('UNCATEGORIZED').'</a>';
		}
		
		return $link;
	}

	/**
	 *	Get a list of categories for a content.
	 */ 
	function getTagLinks($id, $linkTags = true) {
		$database = & JFactory::getDBO();
		
		$query = 'SELECT t.name, t.slug'
				.' FROM #__bloggies_relations AS r'
				.' LEFT JOIN #__bloggies_tags AS t ON t.id = r.tag'
				.' WHERE r.entry='.$id;
		$database->setQuery($query);
		$used = $database->loadObjectList();

		$tags = '';
		$n = count($used);
		for( $i = 0, $n; $i < $n; $i++ ){
			$tag = $used[$i];
			if ($linkTags) {
				$tags .= ', <a href="'.JRoute::_(LyftenBloggieHelperRoute::getTagRoute($tag->slug)).'" rel="tag">'.$tag->name.'</a>';
			} else {
				$tags .= $cat->name;
			}
		}

		return trim($tags, ',');
	}

	/**
	 * Method to fetch the subcategories
	 **/
	function getBookmarks(&$entryID, &$title, $desc, $id=0, $addThisPubId=null)
	{
		global $mainframe;
		$uri    	=& JURI::getInstance();
		$database 	= & JFactory::getDBO();
		
		$query = 'SELECT type, html'
					. ' FROM #__bloggies_bookmarks'
					. ' WHERE published = 1'
					. ' GROUP BY id'
					;
		$database->setQuery($query);
		$Bmarks = $database->loadObjectList();
		
		//clean url
		$url = LyftenBloggieHelperRoute::getEntryRoute($entryID);

		//Make URL SEF
        $url = EntriesHelper::getSEFLink($url);

		// Build html for top and bottom button groups
		$badge 	= '';
		$button = '';
		$tt		=1;
		$i		=0;
		foreach ($Bmarks as $Bmark)
		{
				if ($Bmark->type == 'badge')
				{
					if($badge) $badge .= '<br />';
					$badge .= $Bmark->html;
				}
				else
				{
					$button .= $Bmark->html;
					if($tt==9) {
						$button .= '</p><p>';
						$tt=0;
					}
					$tt++;
					$i++;
				}
		}
		
		if($i > 5) $button = '<a href="javascript:showlayer(\'shareme'.$id.'\');" class="rss-button">Share Me!</a><div style="display: none;" id="shareme'.$id.'" class="shareme"><h2>Share Me!</h2><p>'.$button .= '</p></div>';

		// Replace keystrings in badge and button html
		$bookmarks['badge'] 	= EntriesHelper::_replaceParams($badge, $url, $title, $desc, $addThisPubId);
		$bookmarks['button'] 	= EntriesHelper::_replaceParams($button, $url, $title, $desc, $addThisPubId);
		
		return $bookmarks;
	}

	function _replaceParams($text, $url, $title, $desc, $addThisPubId=null)
	{
		$text = str_replace('***url***', str_replace("'", "", $url), $text);
		$text = str_replace('***url_encoded***', "' + encodeURIComponent('". str_replace("'", "", $url) ."') + '", $text);
		$text = str_replace('***title***', str_replace("'", "", $title), $text);
		$text = str_replace('***title_encoded***', "' + encodeURIComponent('". str_replace("'", "", $title) ."') + '", $text);
		$text = str_replace('***description***', str_replace("'", "", $desc), $text);
		$text = str_replace('***description_encoded***', "' + encodeURIComponent('". str_replace("'", "", $desc) ."') + '", $text);
		$text = str_replace('***imageDirectory***', JURI::base() .'components/com_lyftenbloggie/assets/images/bookmarks', $text);
		$text = str_replace('***bgcolor***', '#ffffff', $text);
		$text = str_replace('***addThisPubId***', $addThisPubId, $text);
		
		return $text;
	}
	
	/**
	 *	Filter BadWords
	 **/ 
	function checkCommentPost($text, $params)
	{
		//makes sure the badword filter is on
		if(!$params->get( 'enableBadWord' )) return $text;
	
		$words	= $params->get( 'theBadWords' );
		$words 	= trim($words, ',');
		$obscenities = split(",", $words);
		foreach ($obscenities as $badword)
		{
			$newtext = preg_replace("/\b".$badword."\b/i", "***" , $text);
		}

        return $newtext;		
	}
	
	/**
	 * Method to get Captcha
	 **/
	function getCaptcha()
	{
		global $mainframe;
		static $captchasessionid = '';
		
		$doc = &JFactory::getDocument();

		$length = 6; // TODO throus function parameter
		$captchaalphanumeric  = '0123456789'; // no 'l', '1', 'o', '0' - trouble for distinct
		$captchanumeric  = '0123456789'; // sound captcha
		$captchalen = strlen( $captchaalphanumeric ) - 1;
		$captchaslist = array();
		$captchareloads = min( 5, 20 );
		for ( $j = 0; $j < $captchareloads; $j++ ) {
			$char = '';
			$number = '';
			for ( $i = 0; $i < $length; $i++ ) {
				$char .= substr( $captchaalphanumeric, mt_rand( 0, $captchalen ), 1 );        
				$number .= substr( $captchanumeric, mt_rand( 0, 9 ), 1 );        
			}
			$captchaslist[] = $number;
		}
	
		// Session >>>
		$lastsession = $_SESSION;
		$lastsessionid = session_id();
		session_write_close();
		
		// captcha session
		ini_set( 'session.save_handler', 'files' );
		if (!$captchasessionid == '') {
			@session_id( $captchasessionid );
			session_start();
		} else {
			session_start();
			session_regenerate_id();
			$captchasessionid = session_id();
			$_SESSION = array();
		}
		
		$_SESSION [ 'captchaslist' ] = $captchaslist;

		session_write_close();
		
		// restore previous session
		$conf = &JFactory::getConfig();
		$handler =  $conf->getValue('config.session_handler', 'none');
		if ($handler == 'none') {
			ini_set( 'session.save_handler', 'files' );
		} else {
			ini_set( 'session.save_handler', 'user' );
			$sessionstorage = new JSessionStorageDatabase();
		}
		session_id($lastsessionid);
		session_start();
		
		$_SESSION [ 'captchasessionid' ] = $captchasessionid;
		setcookie( 'jsid', $captchasessionid, time() + 3600, '/' ); // TODO
		
		// URLs		
		$captcha_URI = JURI::root() . 'components/com_lyftenbloggie/helpers/';
		$image_URI   = $captcha_URI . 'captcha.php?';
		$url_imagecore   = JRoute::_( $image_URI );
		$image_params   = '&amp;sid='.$captchasessionid.'&amp;crt=0';
		$url_image   = $url_imagecore.time().$image_params;

		$captcha = array('url_imagecore'	=>$url_imagecore,
						"image_params" 		=> $image_params,
						"url_image" 		=> $url_image,
						"captchasessionid" 	=> $captchasessionid
						) ;
						
		return $captcha;
	}
	
	/**
	 * Method to check Captcha code
	 **/	
	function checkCaptcha()
	{
		$usersecurecode 	= strtolower(JRequest::getVar( 'captchacode', '', 'post' ));
		$captchasessionid 	= JRequest::getVar( 'captchasessionid', '', 'post' );
		$captcha 			= '';
		$captchasesfrmcurs	= '';
	
		// close and save previous session
		if (session_id()) {
		
			// for backward compatibility
			// will be deprecated in 5.0.0 or wil be used for hi security
			@$captchasesfrmcurs .= $_SESSION['captchasessionid'];
			$lastsession = $_SESSION;
			$lastsessionid = session_id();
		}
		session_write_close();
		
		if ($captchasessionid == '') $captchasessionid = $captchasesfrmcurs;

		// captcha session
		if ( $captchasessionid ) {
			ini_set( 'session.save_handler', 'files' );
			@session_id( $captchasessionid );
			session_start();
			@$captcha = $_SESSION [ 'captcha' ] ;
			session_write_close();
		}

		// restore previous session
		$conf = &JFactory::getConfig();
		$handler =  $conf->getValue('config.session_handler', 'none');
		if ($handler == 'none') {
			ini_set( 'session.save_handler', 'files' );
		} else {
			ini_set( 'session.save_handler', 'user' );
			$sessionstorage = new JSessionStorageDatabase();
		}
		session_id($lastsessionid);
		session_start();
		
		// <<<<< Sessions
		if (($captcha == $usersecurecode) && ( $usersecurecode != '' )) {
			return true;
		}
		return false;		
	}
	
	/**
	 * Closes any open HTML Tags
	* */ 
	function cleanHTML($var){
		preg_match_all("#<([a-z]+)( .*)?(?!/)>#iU",$var,$opened);
		preg_match_all("#</([a-z]+)>#iU",$var,$closed);
		$OpenedCount = count($opened[1]);
		
		if(count($closed[1]) == $OpenedCount) return $var;
		
		$opened = array_reverse($opened[1]);
		for($i=0;$i < $OpenedCount;$i++) {
			if (!in_array($opened[$i],$closed[1]) && $opened[$i] != 'img'){
				$var .= '</'.$opened[$i].'>';
			} else {
				unset($closed[1][array_search($opened[$i],$closed[1])]);
			}
		}
		return $var;
	}

	/**
	 * Method to get suitable link title
	 **/
	function _makeLink($link)
	{
		$replacements_array = array();
		$replacements = "пїЅ?|A, Г‚|A, Д‚|A, Г„|A, Д†|C, Г‡|C, ДЊ|C, ДЋ|D, пїЅ?|D, Г‰|E, пїЅ?|E, Г‹|E, Дљ|E, Г?|I, ГЋ|I, Д№|L, пїЅ?|N, Е‡|N, Г“|O, Г”|O, пїЅ?|O, Г–|O, Е”|R, пїЅ?|R, Е |S, Ељ|O, Е¤|T, Е®|U, Гљ|U, Е°|U, Гњ|U, Г?|Y, ЕЅ|Z, Е№|Z, ГЎ|a, Гў|a, пїЅ?|a, Г¤|a, Д‡|c, Г§|c, Д?|c, Д?|d, Д‘|d, Г©|e, Д™|e, Г«|e, Д›|e, Г­|i, Г®|i, Дє|l, Е„|n, пїЅ?|n, Гі|o, Гґ|o, Е‘|o, Г¶|o, ЕЎ|s, Е›|s, Е™|r, Е•|r, ЕҐ|t, ЕЇ|u, Гє|u, Е±|u, Гј|u, ГЅ|y, Еѕ|z, Еє|z, Л™|-, Гџ|ss, Д„|A, Вµ|u, ГҐ|a, Г…|A, Г¦|ae, Г†|AE, Е“|ce, Е’|CE";
		$items = explode(',', $replacements);
		
		foreach ($items as $item) {
			@list($src, $dst) = explode('|', trim($item));
			$replacements_array[trim($src)] = trim($dst);
		}
			
	    // Replace non-ASCII characters.
	    $link = strtr($link,"\xe1\xc1\xe0\xc0\xe2\xc2\xe4\xc4\xe3\xc3\xe5\xc5\xaa\xe7\xc7\xe9\xc9\xe8\xc8\xea\xca\xeb\xcb\xed\xcd\xec\xcc\xee\xce\xef\xcf\xf1\xd1\xf3\xd3\xf2\xd2\xf4\xd4\xf6\xd6\xf5\xd5\x8\xd8\xba\xf0\xfa\xda\xf9\xd9\xfb\xdb\xfc\xdc\xfd\xdd\xff\xe6\xc6\xdf\xf8","aAaAaAaAaAaAacCeEeEeEeEiIiIiIiInNoOoOoOoOoOoOoouUuUuUuUyYyaAso");
		$link = strtr($link, $replacements_array);
		
	    // remove quotes, spaces, and other illegal characters
	    $link = preg_replace(array('/\'/', '/[^a-zA-Z0-9\-.+]+/', '/(^_|_$)/'), array('', '-', ''), $link);
	    
	    // Replace multiple '-' with a single '-'
	    $link = preg_replace("/-[-]+/e",      "/-/",    $link);
		
		// Remove first occurence of '-'
		$link = preg_replace('{^-}','', $link);
		$link = trim($link, '-');
	
	    return strtolower($link);
	}
}

class LDHTML
{
	/**
	* Method to get the default theme
	**/
	function setTheme($justTheme=0)
	{
		//initialize variables
		$db 		= & JFactory::getDBO();
		$document 	= & JFactory::getDocument();
		
		$query = 'SELECT name'
				. ' FROM #__bloggies_themes'
				. ' WHERE is_default = 1'
				;
		$db->setQuery( $query );
		$theme = $db->loadResult();
		$theme = ($theme)?$theme:'default';

		$themeURL 	= JURI::base().'components/com_lyftenbloggie/addons/themes/'.$theme;
		$themePath 	= JPATH_SITE.DS.'components'.DS.'com_lyftenbloggie'.DS.'addons'.DS.'themes'.DS.$theme.DS;

		//Just return Theme's location
		if($justTheme) return $themeURL;
		
		//Add CSS file
		if(file_exists($themePath.DS.'css'.DS.'style.css')) {
			$document->addStyleSheet($themeURL.'/css/style.css');
		}else{
			$document->addStyleSheet(JURI::base().'components/com_lyftenbloggie/addons/themes/default/css/style.css');
		}

		return true;
	}

	/**
	* Method to get the default theme
	**/
	function setCommentStyle($id=0, $closed=1, $total=0)
	{
		global $mainframe;
	
		//Commenting closed
		if(!$closed) {
			if($total) echo '<div class="post-comment">'.JText::_('COMMENTING CLOSED').'</div>';
			return;
		}

		//No ID set
		if(!$id) return;

		// Initialize variables
		$params 	= & $mainframe->getParams('com_lyftenbloggie');
		$document 	= & JFactory::getDocument();
		$user		= & JFactory::getUser();
		$uri     	=& JFactory::getURI();
		$action		= $uri->toString();

		// Handle Captcha
		if($params->get('enableCaptcha')) {
			$captcha 	= EntriesHelper::getCaptcha();
		}

		//Get Posted Data
		$data 			= array();
		$data['show']	= false;
		
		if($data['comment'] = JRequest::getVar('comment')){
			$data['comment'] = base64_decode($data['comment']);
			$data['show']	= true;
		}else{
			$data['comment'] = 'Комментарий';
		}
		
		if($data['website'] = JRequest::getVar('website')){
			$data['website'] = base64_decode($data['website']);
			$data['show']	= true;
		}else{
			$data['website'] = 'Веб-сайт (не обязательно)';
		}
		
		if($data['email'] = JRequest::getVar('email')){
			$data['email'] = base64_decode($data['email']);
			$data['show']	= true;
		}else{
			$data['email'] = 'Email (не обязательно)';
		}

		//Add Javascript
		if(!$params->get('commentStyle', 0) && $params->get('typeComments', '1')) {
			$document->addScript(JURI::base().'/components/com_lyftenbloggie/assets/js/lyftenbloggie.js');
		}
		if($params->get('useJquery', 0) && $params->get('commentStyle', 0) && $params->get('typeComments', 1)) {
			$document->addScript(JURI::base().'/components/com_lyftenbloggie/assets/js/jquery-1.2.6.js');
		}
		if($params->get('usePHPjquery', 0) && $params->get('commentStyle', 0) && $params->get('typeComments', 1)) {
			$document->addScript(JURI::base().'/components/com_lyftenbloggie/assets/js/jquery.php.js');
			$document->addScript(JURI::base().'/components/com_lyftenbloggie/assets/js/jquery.form.js');
			$js = "var url = \"".JURI::base()."index.php?option=com_lyftenbloggie\";\nformAjax = function () {\nif(jQuery(\"#boxoverlay\").css('display') == \"block\") return false;\njQuery.php(url, jQuery('form#form').formToArray(true));\njQuery('#boxoverlay').css({'display':'block',\n 'opacity':'0.1','width':'100%','height':'100%'}).fadeIn();\njQuery('#facebox .loader').css(\"display\", \"block\");\nreturn false;\n// do an ajax post request\njQuery.ajax({\n// AJAX-specified URL\nurl: url,\n// JSON\ntype: \"POST\",\ndata: jQuery('form#form').formToArray(true),\ndataType : \"json\",\n/* Handlers */\n// Handle the beforeSend event\nbeforeSend: function(){\nreturn php.beforeSend();\n},\n// Handle the success event\nsuccess: function(data, textStatus){\nreturn php.success(data, textStatus);\n},\n// Handle the error event\nerror: function (xmlEr, typeEr, except) {\nreturn php.error(xmlEr, typeEr, except);\n},\n// Handle the complete event\ncomplete: function (XMLHttpRequest, textStatus) {\nreturn php.complete(XMLHttpRequest, textStatus);\n}});\nreturn false;\n}";
			$document->addScriptDeclaration($js);
		}
		if($params->get('commentStyle', 0) && $params->get('typeComments', 1)) {
			$document->addScript(JURI::base().'/components/com_lyftenbloggie/assets/js/facebox.js');
		}
		if($params->get('commentStyle', 0)) {
			if(!$user->guest || $params->get('loginform', 1) ) {
			?>
			<div class="post-comment"><a href="#" onclick="jQuery.facebox({ ajax: '<?php echo JRoute::_('index.php?&option=com_lyftenbloggie&task=comment&id='.$id); ?>' });return false;"><?php echo Jtext::_('LEAVE A COMMENT'); ?></a></div>
			<?php
			}else{
				$url  		= JRoute::_('index.php?option=com_user&view=login&return='.base64_encode($action));			
				echo '<div class="post-comment"><a href="'.$url.'">'.JText::_('PLEASE LOGIN TO COMMENT').'</a></div>';
			}
		}else{
			if(!$user->guest) {
			?>
			<div class="post-comment"><a href="#" onclick="showHiddenDiv('entryComment');return false;" id="entryComment"><?php echo JText::_('LEAVE A COMMENT'); ?></a></div>
			<div class="entryComment" id="entryComment_hidden" style="display:<?php echo ($data['show']) ? 'block' : 'none'; ?>;"> 		
				<div class="entryComment_post">
					<form action="<?php echo $action; ?>" method="post" name="adminForm"> 		
					<h3><?php echo Jtext::_('ADD NEW COMMENT'); ?></h3> 			
					<div class="entryComment_top"> 				
						<div class="inputshadow">
							<textarea name="comment" cols="30" rows="6" onblur="if(this.value=='') this.value='Комментарий';" onfocus="if(this.value=='Комментарий') this.value='';"><?php echo $data['comment']; ?></textarea>
						</div> 			
					</div> 			
					<div class="entryComment_middle"> 				
						<table> 					
							<tbody>
								<tr> 						
									<td class="entryComment_middle_l">
										<div class="inputshadow">
											<input id="name" disabled="true" value="<?php echo $user->get('name'); ?>" type="text">
										</div>
									</td> 						
									<td class="entryComment_middle_r">
										<div class="inputshadow">
											<input id="website" name="website" value="<?php echo $data['website']; ?>" onblur="if(this.value=='') this.value='Веб-сайт (не обязательно)';" onfocus="if(this.value=='Веб-сайт (не обязательно)') this.value='';" type="text">
										</div>
									</td> 					
								</tr> 					
								<tr> 						
									<td class="entryComment_middle_l">
										<div class="inputshadow">
											<input id="email" name="email" value="<?php echo $data['email']; ?>" onblur="if(this.value=='') this.value='Email (не обязательно)';" onfocus="if(this.value=='Email (не обязательно)') this.value='';" type="text">
										</div>
									</td> 						
									<td class="entryComment_middle_r"> 
									<?php if(isset($captcha)) { ?>
											<SCRIPT><!--
											function JGetElementById( s ) {
												var o = (document.getElementById ? document.getElementById(s)
												: document.all[s]);
												return ((o == null) ? false : o);
											}
											function reloadCaptcha() {
												var ocap = JGetElementById( 'captchaimage');
												if (ocap) {
													var today = new Date(); 
													ocap.setAttribute( 'src', '<?php echo $captcha['url_imagecore']; ?>' + today.getTime() + '<?php echo str_replace( '&amp;', '&',  $captcha['image_params'] ); ?>' );
												}
												var ocapc = JGetElementById( 'captchacode');
												ocapc.value="";
												ocapc.focus();
											}
											--></SCRIPT>
											<div class="inputshadow">
												<span class="commentCaptcha"><img id="captchaimage" src="<?php echo $captcha['url_image']; ?>1" title="<?php echo JText::_( 'CAPTCHACODE_TEXT' ) ?>" alt="<?php echo JText::_( 'CAPTCHACODE_TEXT' ) ?>" onclick="reloadCaptcha()" style="cursor: pointer;"></span><input id="captchacode1" value="Введите проверочный код" name="captchacode" onblur="if(this.value=='') this.value='Введите проверочный код';" onfocus="if(this.value=='Введите проверочный код') this.value='';" type="text">
												<input type="hidden" name="captchasessionid" value="<?php echo $captcha['captchasessionid']; ?>" />
											</div>	
										<?php } ?>
									</td> 					
								</tr> 				
							</tbody>
						</table>
					</div>
					<div class="entryComment_footer"> 				
						<button class="entry_button" id="dsq-post-button" onclick="showHiddenDiv('entryComment');return false;">
							<span><?php echo JText::_( 'Cancel' ) ?></span>
						</button>
						<button class="entry_button" id="dsq-post-button" onclick="document.adminForm.submit();">
							<span><?php echo JText::_( 'Post' ) ?></span>
						</button>
					</div>
					<input type="hidden" name="id" value="<?php echo $id; ?>" />
					<input type="hidden" name="referer" value="<?php echo @$_SERVER['HTTP_REFERER']; ?>" />
					<?php echo JHTML::_( 'form.token' ); ?>
					<input type="hidden" name="task" value="postComment" />					
					</form> 
				</div>
			</div>	
			<?php
			}else{
				$url  		= JRoute::_('index.php?option=com_user&view=login&return='.base64_encode($action));			
				echo '<div class="post-comment"><a href="'.$url.'">'.JText::_('Please login to comment').'</a></div>';
			}
		}
	}

	/**
	 * Creates the Avatar URL
	 **/
	function genAvatarURL( $userid, $avatarUsed='default' )
	{
		global $mainframe;
		$db 		= &JFactory::getDBO();

		if( $avatarUsed == 'none' )
		{
			$avatar = COM_LYFTENBLOGGIE_ASSETS.'/avatars/default.png';

		} elseIf( $avatarUsed == 'default' ){
			$query = 'SELECT c.avatar'
						. ' FROM #__bloggies_authors AS c'
						. ' WHERE c.user_id = '. (int)$userid
						;
	        $db->setQuery($query);
	        $avatar = $db->loadResult();
			$avatar = ($avatar)?COM_LYFTENBLOGGIE_ASSETS.'/avatars/'.$avatar:COM_LYFTENBLOGGIE_ASSETS.'/avatars/default.png';

		} elseIf( $avatarUsed == 'jomsocial' ){

	        $query = 'SELECT a.avatar FROM #__community_users AS a WHERE a.userid = '.(int)$userid;
	        $db->setQuery($query);
	        $data = ($data = $db->loadObject()) ? $data : array();
			$avatar =  JURI::base().'components/com_community/assets/default.jpg';
	        if( isset($data->avatar) ) {
				$avatar = $data->avatar ;
	        }

		} elseIf( $avatarUsed == 'brezza' ){
		
			$params	= $mainframe->getParams('com_brezza');

	        $query 	= 'SELECT a.avatar'.
	                  ' FROM #__jomprod_customers AS a' .
					  ' WHERE a.user_id = '.(int)$userid ;
	        $db->setQuery($query);
	        $data 	= ($data = $db->loadObject()) ? $data : array();
			$avatar = JURI::base().$params->get('avatarPath', 'images/brezza/avatars').'/'.(isset($data->avatar)?$data->avatar:'default.png');
			
        } elseIf( $avatarUsed == 'combuilder' ){
		
			$query = 'SELECT a.avatar, a.avatarapproved '.
	                 	'FROM #__comprofiler AS a ' .
	                 	'WHERE a.user_id = '.(int)$userid ;
	        $db->setQuery($query);
	        $data = ($data = $db->loadObject()) ? $data : array();
			$avatar = 'components/com_comprofiler/plugin/templates/default/images/avatar/nophoto_n.png';
	        if( isset($data->avatarapproved) && $data->avatarapproved == 1 && isset($data->avatar)) {
				$avatar = JURI::base().'images/comprofiler/' . $data->avatar ;
	        }
		}
		
		return $avatar;
	}
}
?>