<?php
/**
 * LyftenBloggie 1.0 - Joomla! Blog Manager
 * @package LyftenBloggie 1.0
 * @copyright (C) 2009 Lyften Designs
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.lyften.com/ Official website
 **/
 
// Disallow direct access to this file
defined('_JEXEC') or die('Restricted access');

// Component Helper
jimport('joomla.application.component.helper');

class LyftenBloggieHelperRoute
{
	/**
	 * @param	int	The route of the faq item
	 */
	function getEntryRoute($id)
	{
		$needles = array(
			'entry'  => (int) $id
		);

		//Create the link
		$link = 'index.php?option=com_lyftenbloggie&view=entry';

		$link .= '&id='. $id;

		if($item = LyftenBloggieHelperRoute::_findItem($needles)) {
			$link .= '&Itemid='.$item->id;
		};

		return $link;
	}

	/**
	 * @param	int	The route of the faq item
	 */
	function getEditEntryRoute($id)
	{
		$needles = array(
			'id'  => (int) $id
		);

		//Create the link
		$link = 'index.php?option=com_lyftenbloggie&view=entry&layout=form';

		$link .= '&id='. $id;

		if($item = LyftenBloggieHelperRoute::_findItem($needles)) {
			$link .= '&Itemid='.$item->id;
		};

		return $link;
	}

	/**
	 * @param	int	The route of the Author
	 */
	function getAuthorEntriesRoute($id)
	{
		$needles = array(
			'lyftenbloggie'  => null
		);

		//Create the link
		$link = 'index.php?option=com_lyftenbloggie&author='. $id;

		if($item = LyftenBloggieHelperRoute::_findItem($needles)) {
			$link .= '&Itemid='.$item->id;
		};

		return $link;
	}

	/**
	 * @param	int	The route of the faq item
	 */
	function getMyEntriesRoute()
	{
		$needles = array(
			'id'  => '0'
		);

		//Create the link
		$link = 'index.php?option=com_lyftenbloggie&view=myentries';

		if($item = LyftenBloggieHelperRoute::_findItem($needles)) {
			$link .= '&Itemid='.$item->id;
		};

		return $link;
	}
	
	/**
	 * @param	int	The route of the faq item
	 */
	function getNewEntryRoute()
	{
		$needles = array(
			'id'  => '0'
		);

		//Create the link
		$link = 'index.php?option=com_lyftenbloggie&view=entry&layout=form';

		if($item = LyftenBloggieHelperRoute::_findItem($needles)) {
			$link .= '&Itemid='.$item->id;
		};

		return $link;
	}

	/**
	 * @param	int	The route of the faq item
	 */
	function getMyDetailsRoute($id)
	{
		$needles = array(
			'id'  => (int) $id
		);

		//Create the link
		$link = 'index.php?option=com_lyftenbloggie&view=mydetails&id='.$id;

		if($item = LyftenBloggieHelperRoute::_findItem($needles)) {
			$link .= '&Itemid='.$item->id;
		};

		return $link;
	}

	/**
	 * @param	int	The route of the faq item
	 */
	function getCommentFeedRoute($id, $type)
	{
		$needles = array(
			'id'  => (int) $id,
			'type'  => $type
		);

		//Create the link
		$link = 'index.php?option=com_lyftenbloggie&task=feed&type='.$type.'&id='. $id;
	
		if($item = LyftenBloggieHelperRoute::_findItem($needles)) {
			$link .= '&Itemid='.$item->id;
		};

		return $link;
	}

	/**
	 * @param	int	The route of the faq item
	 **/
	function getPermalink($id)
	{
		$needles = array(
			'item'  => (int) $id
		);

		//Create the link
		$link = 'index.php?option=com_lyftenbloggie&show='. $id;

		if($item = LyftenBloggieHelperRoute::_findItem($needles)) {
			$link .= '&Itemid='.$item->id;
		};

		return $link;
	}

	function getCategoryRoute($catname)
	{
		$catname = strtolower($catname);

		$needles = array(
			'category' => $catname
		);

		//Create the link
		$link = 'index.php?option=com_lyftenbloggie&category='.$catname;

		if($item = LyftenBloggieHelperRoute::_findItem($needles)) {
			$link .= '&Itemid='.$item->id;
		};

		return $link;
	}
	
	function getTagRoute($tag)
	{
		$needles = array(
			'tag' => $tag
		);

		//Create the link
		$link = 'index.php?option=com_lyftenbloggie&tag='.$tag;

		if($item = LyftenBloggieHelperRoute::_findItem($needles)) {
			$link .= '&Itemid='.$item->id;
		};

		return $link;
	}
	
	function getBlogFeedRoute($type)
	{
		$needles = array(
			'format' => 'feed',
			'type' => $type
		);

		//Create the link
		$link = 'index.php?option=com_lyftenbloggie&task=feed&type='.$type;
		if($item = LyftenBloggieHelperRoute::_findItem($needles)) {
			$link .= '&Itemid='.$item->id;
		};
		return $link;
	}
	
	function getArchiveRoute($archivedate, $mn)
	{
		$needles = array(
			'archive' => $archivedate,
			'mn' => $mn
		);

		//Create the link
		$link = 'index.php?option=com_lyftenbloggie&archive='.$archivedate.'&mn='.$mn;

		if($item = LyftenBloggieHelperRoute::_findItem($needles)) {
			$link .= '&Itemid='.$item->id;
		};

		return $link;
	}

	function _findItem($needles)
	{
		$component =& JComponentHelper::getComponent('com_lyftenbloggie');

		$menus	= &JApplication::getMenu('site', array());
		$items	= $menus->getItems('componentid', $component->id);
		$user 	= & JFactory::getUser();
		$access = (int)$user->get('aid');

		$match = null;

		foreach($needles as $needle => $id)
		{
			if(empty($items)) return;
			
			foreach($items as $item)
			{
				if ((@$item->query['view'] == $needle) && (@$item->query['id'] == $id)) {
					$match = $item;
					break;
				}
			}

			//no menuitem exists -> return first possible match
			if(!$match)
			{
				foreach($items as $item)
				{
					if (@$item->published == 1 && @$item->access <= $access && @$item->query['view'] != 'favourites' && @$item->query['layout'] != 'form') {
						$match = $item;
						break;
					}
				}
			}
			
			if(isset($match)) {
				break;
			}
		}

		return $match;
	}
}
?>
