<?php
/**
 * JomProducts 1.0 - Joomla! Product Manager
 * @package JomProducts 1.0
 * @copyright (C) 2009 Lyften Designs
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.lyften.com/ Official website
 **/
 
// Disallow direct access to this file
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

/**
 * @package Joomla
 * @subpackage JomProducts
 * @since 1.0
 */
class LyftenBloggieModelLyftenBloggie extends JModel
{
	var $_data = null;

	/**
	 * Constructor
	 **/
	function __construct()
	{
		parent::__construct();
	}

	function getLocalBuild()
	{
		$versionString	= $this->getFullLocalVersion();
		$tmpArray		= explode( '.' , $versionString );
		
		if( isset($tmpArray[2]) )
		{
			return $tmpArray[2];
		}
		
		// Unknown build number.
		return 0;
	}
	
	function getLocalVersion()
	{
		$versionString	= $this->getFullLocalVersion();
		$tmpArray		= explode( '.' , $versionString );
		
		if( isset($tmpArray[0] ) && isset( $tmpArray[1] ) )
		{
			return doubleval( $tmpArray[0] . '.' . $tmpArray[1] ); 
		}
		return 0;
	}
	
	function getFullLocalVersion()
	{
		static $version		= '';

		if (!@ini_get('safe_mode')) set_time_limit(180);
		
		if( empty( $version ) )
		{
			$parser		=& JFactory::getXMLParser('Simple');
	
			// Load the local XML file first to get the local version
			$xml		= JPATH_COMPONENT . DS . 'lyftenbloggie.xml';
			
			$parser->loadFile( $xml );
			$document	=& $parser->document;
	
			$element		=& $document->getElementByPath( 'version' );
			$version		= $element->data();
		}
		return $version;
	}

	function getIncomingLinks()
	{
		global $mainframe;
		
		if (!@ini_get('safe_mode')) set_time_limit(180);
		
		// Require the RSS Functions
		require_once (JPATH_COMPONENT.DS.'libraries'.DS.'rss.php');
		
		$rssurl='http://blogsearch.google.com/blogsearch_feeds?hl=en&scoring=d&ie=utf-8&num=10&output=rss&partner=wordpress&q=link:'.$mainframe->getSiteURL();

		$items	= RSSFunction::getRSSFeed($rssurl);
		
		return $items;
	}


	/**
	 * Method to get general stats
	 **/
	function getGeneralstats()
	{
		$_products = array();

		/*
		* Get total number of entries
		*/
		$query = 'SELECT count(id)'
					. ' FROM #__bloggies_entries'
					;

		$this->_db->SetQuery($query);
  		$_products['total'] = $this->_db->loadResult();

 		/*
		* Get total number of pending entries
		*/
		$query = 'SELECT count(id)'
					. ' FROM #__bloggies_entries'
					. " WHERE state = 2"
					;

		$this->_db->SetQuery($query);
  		$_products['pending'] = $this->_db->loadResult();

 		/*
		* Get total number of approved entries
		*/
		$query = 'SELECT count(id)'
					. ' FROM #__bloggies_entries'
					. " WHERE state = 1"
					;

		$this->_db->SetQuery($query);
  		$_products['approved'] = $this->_db->loadResult();
  		
		/*
		* Get total number of tags
		*/
		$query = 'SELECT count(id)'
					. ' FROM #__bloggies_tags'
					;

		$this->_db->SetQuery($query);
  		$_products['tags'] = $this->_db->loadResult();
  		
  		/*
		* Get number of all trackback
		*/
		$query = "SELECT count(id)"
					. " FROM #__bloggies_comments"
					. " WHERE type = 2"
					. " AND state = 1"
					;

		$this->_db->SetQuery($query);
  		$_products['trackback'] = $this->_db->loadResult();
  		
  		/*
		* Get number of all Reports
		*/
		$query = "SELECT count(id)"
					. " FROM #__bloggies_reports"
					;

		$this->_db->SetQuery($query);
  		$_products['reports'] = $this->_db->loadResult();
  		
  		/*
		* Get number of all categories
		*/
		$query = "SELECT count(id)"
					. " FROM #__bloggies_categories"
					. " WHERE published = '1'"
					;

		$this->_db->SetQuery($query);
  		$_products['categories'] = $this->_db->loadResult();
  		
  		/*
		* Get number of all comments
		*/
		$query = "SELECT count(id)"
					. " FROM #__bloggies_comments"
					. " WHERE type = '1'"
					;

		$this->_db->SetQuery($query);
  		$_products['comments'] = $this->_db->loadResult();
  		
		return $_products;
	}

	/**
	 * Method to get popular data
	 **/
	function getPopular()
	{
		$query = 'SELECT id, title, hits'
				. ' FROM #__bloggies_entries'
				. ' ORDER BY hits DESC'
				. ' LIMIT 5'
				;

		$this->_db->SetQuery($query);
  		$hits = $this->_db->loadObjectList();
  		
  		return $hits;
	}	

	/**
	 * Method to get hits
	 **/
	function fixPermlinks()
	{
		$query = 'SELECT e.id,e.title,p.entryid'
				. ' FROM #__bloggies_entries AS e'
				. ' LEFT OUTER JOIN #__bloggies_permalinks AS p ON p.entryid = e.id'
				. ' WHERE p.entryid IS NULL'
				;
		$this->_db->setQuery($query);
		$rows = $this->_db->loadObjectlist();
		
		$results['new_permalinks'] = 0;
		if ($rows) {
			$results['new_permalinks'] = count($rows);
			foreach ($rows as $row) {
				$title = $row->title;
				$link = $this->_makeLink(trim($title . ".html"));
				$link = preg_replace('/[!@#$%\^&*\(\)\+=\{\}\[\]|\\<">,\\/\^\*;:\?\'\\\]/', "", $link);

				$this->_db->setQuery("SELECT * from #__bloggies_permalinks WHERE permalink='$link' and entryid!='$row->id'");
				$linkExists = $this->_db->loadResult();
		
				if ($linkExists) {
					$link = $this->_makeLink(trim($title));
					$plink = "$link-$uid.html";
					$this->_db->setQuery("SELECT entryid from #__bloggies_permalinks WHERE permalink='$plink' and entryid!='$row->id'");
					$count = 0;
					while ($this->_db->loadResult()) {
						$count++;
						$plink = "$link-{$row->id}-$count.html";
						$this->_db->setQuery("SELECT entryid from #__bloggies_permalinks WHERE permalink='$plink' and entryid!='$row->id'");
					}
					$this->_db->setQuery("INSERT INTO #__bloggies_permalinks SET permalink='$plink',entryid='$row->id'");
					if(!$this->_db->query()){
						$results['msg'] = $this->_db->getErrorMsg();	
					}					
				} else {
					$this->_db->setQuery("INSERT INTO #__bloggies_permalinks SET permalink='$link',entryid='$row->id'");
					if(!$this->_db->query()){
						$results['msg'] = $this->_db->getErrorMsg();	
					}						
				}
			}
		}
	
		$this->_db->setQuery("SELECT entryid, permalink from #__bloggies_permalinks");
		$permalinks = $this->_db->loadObjectlist();
		$results['modified_permalinks'] = 0;
		if ($permalinks)
		{
			$results['modified_permalinks'] = count($permalinks);

			foreach ($permalinks as $permalink)
			{
				$uid = $permalink->entryid;
				$link = $permalink->permalink;
				$link = $this->_makeLink(trim($link));

				$this->_db->setQuery("SELECT * from #__bloggies_permalinks WHERE permalink='$link' and entryid!='$uid'");
				$linkExists = $this->_db->loadResult();

				if ($linkExists) {
					if (substr($link, strlen($link)-5, 5)==".html")
					$link = substr($link, 0, strlen($link)-5);

					$plink = "$link-$uid.html";
					$this->_db->setQuery("SELECT entryid from #__bloggies_permalinks WHERE permalink='$plink' and entryid!='$uid'");
					$count = 0;

					while ($this->_db->loadResult()) {
						$count++;
						$plink = "$link-$uid-$count.html";
						$this->_db->setQuery("SELECT entryid from #__bloggies_permalinks WHERE permalink='$plink' and entryid!='$uid'");
					}
					$this->_db->setQuery("UPDATE #__bloggies_permalinks SET permalink='$plink' WHERE entryid='$uid'");
					if(!$this->_db->query()){
						$results['msg'] = $this->_db->getErrorMsg();	
					}						
				} else {
					$this->_db->setQuery("UPDATE #__bloggies_permalinks SET permalink='$link' WHERE entryid=$uid");
					if(!$this->_db->query()){
						$results['msg'] = $this->_db->getErrorMsg();	
					}						
				}
			}
		}
		
		return $results;
	}
	
	/**
	 * Method to get suitable link title
	 **/
	function _makeLink($link)
	{
		$replacements_array = array();
		$replacements = "�?|A, Â|A, Ă|A, Ä|A, Ć|C, Ç|C, Č|C, Ď|D, �?|D, É|E, �?|E, Ë|E, Ě|E, ?|I, Î|I, Ĺ|L, �?|N, Ň|N, Ó|O, Ô|O, �?|O, Ö|O, Ŕ|R, �?|R, Š|S, Ś|O, Ť|T, Ů|U, Ú|U, Ű|U, Ü|U, ?|Y, Ž|Z, Ź|Z, á|a, â|a, �?|a, ä|a, ć|c, ç|c, ?|c, ?|d, đ|d, é|e, ę|e, ë|e, ě|e, í|i, î|i, ĺ|l, ń|n, �?|n, ó|o, ô|o, ő|o, ö|o, š|s, ś|s, ř|r, ŕ|r, ť|t, ů|u, ú|u, ű|u, ü|u, ý|y, ž|z, ź|z, ˙|-, ß|ss, Ą|A, µ|u, å|a, Å|A, æ|ae, Æ|AE, œ|ce, Œ|CE";
		$items = explode(',', $replacements);
		
		foreach ($items as $item) {
			@list($src, $dst) = explode('|', trim($item));
			$replacements_array[trim($src)] = trim($dst);
		}
			
	    // Replace non-ASCII characters.
	    $link = strtr($link,"\xe1\xc1\xe0\xc0\xe2\xc2\xe4\xc4\xe3\xc3\xe5\xc5\xaa\xe7\xc7\xe9\xc9\xe8\xc8\xea\xca\xeb\xcb\xed\xcd\xec\xcc\xee\xce\xef\xcf\xf1\xd1\xf3\xd3\xf2\xd2\xf4\xd4\xf6\xd6\xf5\xd5\x8\xd8\xba\xf0\xfa\xda\xf9\xd9\xfb\xdb\xfc\xdc\xfd\xdd\xff\xe6\xc6\xdf\xf8","aAaAaAaAaAaAacCeEeEeEeEiIiIiIiInNoOoOoOoOoOoOoouUuUuUuUyYyaAso");
		$link = strtr($link, $replacements_array);
		
	    // remove quotes, spaces, and other illegal characters
	    $link = preg_replace(array('/\'/', '/[^a-zA-Z0-9\-.+]+/', '/(^_|_$)/'), array('', '-', ''), $link);
	    
	    // Replace multiple '-' with a single '-'
	    $link = preg_replace("/-[-]+/e",      "/-/",    $link);
		
		// Remove first occurence of '-'
		$link = preg_replace('{^-}','', $link);
		
	    return $link;
	}
}
?>