<?php
/**
 * LyftenBloggie 1.0 - Joomla! Blog Manager
 * @package LyftenBloggie 1.0
 * @copyright (C) 2009 Lyften Designs
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.lyften.com/ Official website
 **/
 
// Disallow direct access to this file
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class LyftenBloggieModelMyDetails extends JModel
{
	var $_id 		= null;
	var $_author 	= null;

	/**
	 * Constructor
	 **/
	function __construct()
	{
		parent::__construct();

		$id = JArrayHelper::getValue( $_REQUEST, 'id', 0 );
		$this->setId($id);
	}

	/**
	 * Method to set the identifier
	 **/
	function setId($id)
	{
		// Set author id and wipe data
		$this->_id	    = $id;
		$this->_author	= null;
	}

	/**
	 * Overridden get method to get properties from the author
	 **/
	function get($property, $default=null)
	{
		if ($this->_loadAuthor()) {
			if(isset($this->_author->$property)) {
				return $this->_author->$property;
			}
		}
		return $default;
	}

	/**
	 * Method to get author data
	 **/
	function &getAuthor()
	{
		if ($this->_loadAuthor())
		{

		}

		return $this->_author;
	}

	/**
	 * Method to load author data
	 **/
	function _loadAuthor()
	{
		// Lets load the author if it doesn't already exist
		if (empty($this->_author))
		{
			//Ensures the user is the author
			$user =& JFactory::getUser();
			if($user->guest) return false;
			
			$this->_id = $user->get('id');
		
			$query = 'SELECT *'
					. ' FROM #__bloggies_authors'
					. ' WHERE user_id = '.$this->_id
					. ' AND published = 1'
					;
			$this->_db->setQuery($query);
			$this->_author = $this->_db->loadObject();

			return (boolean) $this->_author;
		}
		return true;
	}

	/**
	 * Method to get all Categories
	 **/
	function getAboutBox()
	{
		$query = 'SELECT published' .
				' FROM #__bloggies_sideitems' .
				' WHERE LOWER(title) = \'aboutblock\'';
		$this->_db->setQuery($query);
		$list['aboutbox'] = $this->_db->loadResult();

		$query = 'SELECT html' .
				' FROM #__bloggies_sideitems' .
				' WHERE LOWER(title) = \'authortools\'';
		$this->_db->setQuery($query);
		$authortools = $this->_db->loadResult();
		
		$params = new JParameter($authortools);
		$list['authortools'] = $params->get('showAboutBoxOptions');
		
		//echo (($params->get('showAboutBoxOptions')) && $aboutbox);

		return $list;
	}
	
	/**
	 * Method to checkin/unlock the author
	 **/
	function checkin()
	{
		if ($this->_id)
		{
			$author = & JTable::getInstance('authors', 'Table');
			return $author->checkin($this->_id);
		}
		return false;
	}

	/**
	 * Method to checkout/lock the author
	 **/
	function checkout($uid = null)
	{
		if ($this->_id)
		{
			// Make sure we have a user id to checkout the author with
			if (is_null($uid)) {
				$user	=& JFactory::getUser();
				$uid	= $user->get('id');
			}
			// Lets get to it and checkout the thing...
			$author = & JTable::getInstance('authors', 'Table');
			if(!$author->checkout($uid, $this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}

			return true;
		}
		return false;
	}

	/**
	 * Tests if the author is checked out
	 **/
	function isCheckedOut( $uid=0 )
	{
		if ($this->_loadAuthor())
		{
			if ($uid) {
				return ($this->_author->checked_out && $this->_author->checked_out != $uid);
			} else {
				return $this->_author->checked_out;
			}
		} elseif ($this->_id < 1) {
			return false;
		} else {
			JError::raiseWarning( 0, 'UNABLE LOAD DATA');
			return false;
		}
	}

	/**
	 * Method to store the author
	 **/
	function store($data)
	{
		$author  =& $this->getTable('authors', 'Table');

		// bind it to the table
		if (!$author->bind($data)) {
			$this->setError(500, $this->_db->getErrorMsg() );
			return false;
		}
		
		//set user ID
		$user 				= & JFactory::getUser();
		$author->user_id 	= $user->get('id');

		if (isset( $_FILES['avatar']) and !$_FILES['avatar']['error'] ) {
			//Get the blog author helper
			require_once( JPATH_COMPONENT_ADMINISTRATOR.DS.'helper.php' );
			$author->avatar = BlogAuthor::createAvatar($_FILES['avatar']['tmp_name'], $user->get('id')."_avatar.jpg", '', $_FILES['avatar']['name']);
		}
			
		// Get a state and parameter variables from the request
		$params			= JRequest::getVar( 'params', null, 'post', 'array' );		
		
		// Build parameter INI string
		if (is_array($params))
		{
			$txt = array ();
			foreach ($params as $k => $v) {
				$txt[] = "$k=$v";
			}
			$author->attribs = implode("\n", $txt);
		}
		
		// Make sure the data is valid
		if (!$author->check()) {
			$this->setError($author->getError());
			return false;
		}

		// Store it in the db
		if (!$author->store()) {
			$this->setError(500, $this->_db->getErrorMsg() );
			return false;
		}
		
		$this->_author	=& $author;
		
		return true;
	}
}
?>