<?php
/**
 * LyftenBloggie 1.0 - Joomla! Blog Manager
 * @package LyftenBloggie 1.0
 * @copyright (C) 2009 Lyften Designs
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.lyften.com/ Official website
 **/
 
// Disallow direct access to this file
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

/**
 * @package Joomla
 * @subpackage LyftenBloggie
 * @since 1.0
 */
class LyftenBloggieModelSideitem extends JModel
{

	var $_sideitem = null;

	/**
	 * Constructor
	 **/
	function __construct()
	{
		parent::__construct();

		$array = JRequest::getVar('cid',  0, '', 'array');
		$this->setId((int)$array[0]);
	}

	/**
	 * Method to set the identifier
	 **/
	function setId($id)
	{
		// Set sideitem id and wipe data
		$this->_id	    	= $id;
		$this->_sideitem	= null;
	}
	
	/**
	 * Overridden get method to get properties from the sideitem
	 **/
	function get($property, $default=null)
	{
		if ($this->_loadSideitem()) {
			if(isset($this->_sideitem->$property)) {
				return $this->_sideitem->$property;
			}
		}
		return $default;
	}

	/**
	 * Method to get sideitem data
	 **/
	function &getSideitem()
	{
		if ($this->_loadSideitem())
		{

		}
		else  $this->_initSideitem();

		return $this->_sideitem;
	}

	/**
	 * Method to load sideitem data
	 **/
	function _loadSideitem()
	{
		// Lets load the sideitem if it doesn't already exist
		if (empty($this->_sideitem))
		{
			$query = 'SELECT *'
					. ' FROM #__bloggies_sideitems'
					. ' WHERE id = '.$this->_id
					;
			$this->_db->setQuery($query);
			$this->_sideitem = $this->_db->loadObject();

			return (boolean) $this->_sideitem;
		}
		return true;
	}

	/**
	 * Method to initialise the sideitem data
	 **/
	function _initSideitem()
	{
		// Lets load the sideitem if it doesn't already exist
		if (empty($this->_sideitem))
		{
			$sideitem = new stdClass();
			$sideitem->id					= 0;
			$sideitem->title				= null;
			$sideitem->custom_title			= '';
			$sideitem->html					= null;
			$sideitem->type					= 'script';
			$sideitem->published			= 1;
			$this->_sideitem				= $sideitem;
			return (boolean) $this->_sideitem;
		}
		return true;
	}

	/**
	 * Method to store the sideitem
	 **/
	function store($data)
	{
		$sideitem  =& $this->getTable('sideitems', 'Table');

		// bind it to the table
		if (!$sideitem->bind($data)) {
			$this->setError(500, $this->_db->getErrorMsg() );
			return false;
		}
		
		if (!$sideitem->id) {
			$sideitem->ordering = $sideitem->getNextOrder();
		}

		// if the side item is a plugin get the parameters
		if(strtolower($sideitem->type) == 'plugin') {
			$params		= JRequest::getVar( 'params', null, 'post', 'array' );		
			
			if (is_array($params))
			{
				$txt = array ();
				foreach ($params as $k => $v) {
					$txt[] = "$k=$v";
				}
				$sideitem->html = implode("\n", $txt);
			}
		}
		
		// Make sure the data is valid
		if (!$sideitem->check()) {
			$this->setError($sideitem->getError());
			return false;
		}

		// Store it in the db
		if (!$sideitem->store()) {
			$this->setError(500, $this->_db->getErrorMsg() );
			return false;
		}
		
		$this->_sideitem	=& $sideitem;
		
		return true;
	}
}
?>