<?php
/**
 * LyftenBloggie 1.0 - Joomla! Blog Manager
 * @package LyftenBloggie 1.0
 * @copyright (C) 2009 Lyften Designs
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.lyften.com/ Official website
 **/
 
// Disallow direct access to this file
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view');

class LyftenBloggieViewAuthor extends JView {

	function display($tpl = null)
	{
		global $mainframe;

		//Load pane behavior
		jimport('joomla.html.pane');

		//initialise variables
		$document	= & JFactory::getDocument();
		$user 		= & JFactory::getUser();
		$tabs 		= & JPane::getInstance('tabs');

		//get vars
		$cid 		= JRequest::getVar( 'cid' );

		//add css to document
		$document->addStyleSheet('components/com_lyftenbloggie/assets/css/style.css');

		//create the toolbar
		if ( $cid ) {
			JToolBarHelper::title( JText::_( 'EDIT AUTHOR' ), 'lbauthor' );

		} else {
			JToolBarHelper::title( JText::_( 'NEW AUTHOR' ), 'lbauthor' );
		}
		JToolBarHelper::save();
		JToolBarHelper::apply();
		JToolBarHelper::divider();
		JToolBarHelper::cancel();
		JToolBarHelper::spacer();

		//Get data from the model
		$model		= & $this->getModel();
		$row     	= & $this->get( 'Author' );
		$users     	= (!$row->id)?$this->get( 'Users' ):'';
		
		//fail if checked out not by 'me'
		if ($row->id) {
			if ($model->isCheckedOut( $user->get('id') )) {
				JError::raiseWarning( 'SOME_ERROR_CODE', $row->title.' '.JText::_( 'EDITED BY ANOTHER ADMIN' ));
				$mainframe->redirect( 'index.php?option=com_lyftenbloggie&view=categories' );
			}
		}

		//clean data
		JFilterOutput::objectHTMLSafe( $row, ENT_QUOTES, 'about' );
		
		//Get permissions
		$permission = new JParameter( $row->permission );
		
		// Create the form
		$form = new JParameter('', JPATH_COMPONENT.DS.'models'.DS.'aboutblock.xml');
		$form->loadINI($row->attribs);

		JHTML::_('behavior.tooltip');
	
		//assign vars to view
		$this->assignRef('permission'   , $permission);
		$this->assignRef('form'      	, $form);
		$this->assignRef('users'      	, $users);
		$this->assignRef('row'      	, $row);
		$this->assignRef('tabs'			, $tabs);

		parent::display($tpl);
	}
}
?>