<?php
/**
 * LyftenBloggie 1.0 - Joomla! Blog Manager
 * @package LyftenBloggie 1.0
 * @copyright (C) 2009 Lyften Designs
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.lyften.com/ Official website
 **/
 
// Disallow direct access to this file
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view');

/**
 * @package Joomla
 * @subpackage LyftenBloggie
 * @since 1.0
 */
class LyftenBloggieViewComments extends JView
{
	/**
	 * Creates the comments page
	 **/
	function display( $tpl = null )
	{
		global $mainframe;

		//initialize variables
		$document 	= & JFactory::getDocument();
		$user		= & JFactory::getUser();
		$menus		= & JSite::getMenu();
		$menu    	= $menus->getActive();
		$params 	= & $mainframe->getParams('com_lyftenbloggie');
		
		//Load route helper
		require_once (JPATH_SITE.DS.'components'.DS.'com_lyftenbloggie'.DS.'helpers'.DS.'route.php');

		$limitstart	= JRequest::getVar('limitstart', 0, '', 'int');
		$id			= JRequest::getInt('id', 0);

		if($this->getLayout() == 'form') {
			$this->_displayForm($tpl);
			return;
		}

		//Set theme
		LDHTML::setTheme();

		//get faq Entry data
		$entry 				= & $this->get('Entry');

		//Make sure entry is there
		if (($entry->id == 0))
		{	
			return JError::raiseError( 404, JText::sprintf( 'ENTRY BLANK NOT FOUND', $id ) );
		}

		//Get entry params
		$pparams	= new JParameter($entry->attribs);	
	
		$comments	= & $this->get('Comments');
		$totalcoms	= & $this->get('Total');
		$pageNav 	= & $this->get( 'Pagination' );
	
		$iparams	=& $entry->attribs;
		$params->merge($iparams);
		
		//pathway
		$pathway 	= & $mainframe->getPathWay();
		$pathway->addItem( $this->escape($entry->cattitle), JRoute::_('index.php?category='.$entry->categoryslug));
		$pathway->addItem( $this->escape($entry->title), JRoute::_('index.php?view=entry&id='.$entry->id));
		$pathway->addItem( JText::_('COMMENTS'));
		
		/*
		 * Handle the metadata
		 */
		if (is_object($menu)) {
			$menu_params = new JParameter( $menu->params );
			if (!$menu_params->get( 'page_title')) {
				$params->set('page_title',	$entry->title);
			}
		} else {
			$params->set('page_title',	$entry->title);
		}

		/*
		 * Create the document title
		 */
		$document->setTitle($entry->title.' - '.JText::_('COMMENTS'));
		
		if ($entry->metadesc) {
			$document->setDescription( $entry->metadesc );
		}
		
		if ($entry->metakey) {
			$document->setMetadata('keywords', $entry->metakey);
		}
		
		if ($mainframe->getCfg('MetaTitle') == '1') {
			$mainframe->addMetaTag('title', $entry->title);
		}
		
		if ($mainframe->getCfg('MetaAuthor') == '1') {
			$mainframe->addMetaTag('author', $entry->author);
		}

		$mdata = new JParameter($entry->metadata);
		$mdata = $mdata->toArray();
		foreach ($mdata as $k => $v)
		{
			if ($v) {
				$document->setMetadata($k, $v);
			}
		}
		
		//assign variables to template
		$this->assignRef('comments' , 		$comments);
		$this->assignRef('totalcoms' , 		$totalcoms);
		$this->assignRef('pageNav' ,		$pageNav);
		$this->assignRef('entry' , 			$entry);
		$this->assignRef('allowReport' , 	$params->get('allowReport'));
		$this->assignRef('lists' , 			$lists);
		$this->assignRef('params' , 		$params);
		$this->assignRef('user' , 			$user);
		
		parent::display($tpl);

	}
}
?>