<?php
/**
 * LyftenBloggie 1.0 - Joomla! Blog Manager
 * @package LyftenBloggie 1.0
 * @copyright (C) 2009 Lyften Designs
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.lyften.com/ Official website
 **/
 
// Disallow direct access to this file
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view');

/**
 * @package Joomla
 * @subpackage LyftenBloggie
 * @since 1.0
 */
class LyftenBloggieViewEntry extends JView
{
	/**
	 * Creates the Entry page
	 **/
	function display( $tpl = null )
	{
		global $mainframe;

		//initialize variables
		$document 	= & JFactory::getDocument();
		$user		= & JFactory::getUser();
		$menus		= & JSite::getMenu();
		$menu    	= $menus->getActive();
		$dispatcher = & JDispatcher::getInstance();
		$params 	= & $mainframe->getParams('com_lyftenbloggie');
		$uri     	=& JFactory::getURI();

		//Load route helper
		require_once (JPATH_SITE.DS.'components'.DS.'com_lyftenbloggie'.DS.'helpers'.DS.'route.php');

		$limitstart	= JRequest::getVar('limitstart', 0, '', 'int');
		$cid		= JRequest::getInt('cid', 0);

		if($this->getLayout() == 'form') {
			$this->_displayForm($tpl);
			return;
		}

		//Set theme
		LDHTML::setTheme();

		//get faq Entry data
		$entry 				= & $this->get('Entry');

		//Assign Comment form
		if($entry->allowComments) {
			$this->assign('action'				, $uri->toString());
		}
		
		$iparams	=& $entry->attribs;
		$params->merge($iparams);
		
		if (($entry->id == 0))
		{
			$id	= JRequest::getInt('id', 0);
			JError::raiseWarning( 'SOME_ERROR_CODE', JText::sprintf( 'ENTRY BLANK NOT FOUND', $id ));
			$mainframe->redirect( JRoute::_('index.php?option=com_lyftenbloggie', false) );
		}
		
		//pathway
		$pathway 	= & $mainframe->getPathWay();
		$pathway->addItem( $this->escape($entry->cattitle), JRoute::_('index.php?category='.$entry->categoryslug));
		$pathway->addItem( $this->escape($entry->title), JRoute::_('index.php?view=entry&id='.$entry->id));
		
		/*
		 * Handle the metadata
		 */
		if (is_object($menu)) {
			$menu_params = new JParameter( $menu->params );
			if (!$menu_params->get( 'page_title')) {
				$params->set('page_title',	$entry->title);
			}
		} else {
			$params->set('page_title',	$entry->title);
		}

		/*
		 * Create the document title
		 * 
		 * First is to check if we have a category id, if yes add it.
		 * If we haven't one than we accessed this screen direct via the menu and don't add the parent category
		 */
		if($cid) {
			$parentcat = array_pop($parents);
			$doc_title = $parentcat->title.' - '.$params->get( 'page_title' );
		} else {
			$doc_title = $params->get( 'page_title' );
		}
		
		$document->setTitle($doc_title);
		
		if ($entry->metadesc) {
			$document->setDescription( $entry->metadesc );
		}
		
		if ($entry->metakey) {
			$document->setMetadata('keywords', $entry->metakey);
		}
		
		if ($mainframe->getCfg('MetaTitle') == '1') {
			$mainframe->addMetaTag('title', $entry->title);
		}
		
		if ($mainframe->getCfg('MetaAuthor') == '1') {
			$mainframe->addMetaTag('author', $entry->author);
		}

		$mdata = new JParameter($entry->metadata);
		$mdata = $mdata->toArray();
		foreach ($mdata as $k => $v)
		{
			if ($v) {
				$document->setMetadata($k, $v);
			}
		}

		// Process the prepare content plugins
		JPluginHelper::importPlugin('content');
		$results = $dispatcher->trigger('onPrepareContent', array (& $entry, & $params, $limitstart));

		// Handle display events
		$entry->event = new stdClass();
		$results = $dispatcher->trigger('onAfterDisplayTitle', array ($entry, &$params, $limitstart));
		$entry->event->afterDisplayTitle = trim(implode("\n", $results));

		$results = $dispatcher->trigger('onBeforeDisplayContent', array (& $entry, & $params, $limitstart));
		$entry->event->beforeDisplayContent = trim(implode("\n", $results));

		$results = $dispatcher->trigger('onAfterDisplayContent', array (& $entry, & $params, $limitstart));
		$entry->event->afterDisplayContent = trim(implode("\n", $results));
		
		//get comments if enabled
		$comments	= & $this->get('Comments');
		$pageNav 	= & $this->get( 'Pagination' );
		$totalcoms	= & $this->get('Total');

		//assign variables to template
		$this->assignRef('entry' , 				$entry);
		$this->assignRef('params' , 			$params);
		$this->assignRef('print_link' , 		$print_link);
		$this->assignRef('lists' , 				$lists);
		$this->assignRef('comments' , 			$comments);
		$this->assignRef('totalcoms' , 			$totalcoms);
		$this->assignRef('pageNav' ,			$pageNav);
		$this->assignRef('user' ,				$user);
		
		parent::display($tpl);
	}
	
	/**
	 * Creates the entry submit form
	 **/
	function _displayForm($tpl)
	{
		global $mainframe;
		
		//Load pane behavior
		jimport('joomla.html.pane');

		//Initialize variables
		$document	=& JFactory::getDocument();
		$user		= EntriesHelper::getAuthor();
		$db  		= & JFactory::getDBO();
		$params		=& $mainframe->getParams('com_lyftenbloggie');
		$pane 		= & JPane::getInstance('sliders');
		$nullDate 	= $db->getNullDate();	
		$lists 		= array();
		$disabled	= '';
		$uri     	=& JFactory::getURI();

		// Must be logged in
		if ($user->user_id == 'no' && !$user->username) {
			$return		= $uri->toString();
			$url  		= 'index.php?option=com_user&view=login&return='.base64_encode($return);
			$mainframe->redirect( $url, JText::_("PLEASE LOGIN") );
		}

		//Add the js includes to the document <head> section
		JHTML::_('behavior.formvalidation');
		JHTML::_('behavior.tooltip');

		// fail if checked out not by 'me'
		$model			= & $this->getModel();
		$row     		= & $this->get( 'Entry' );

		// fail if checked out not by 'me'		
		if ($row->id) {
			if ($model->isCheckedOut( $user->user_id )) {
				JError::raiseWarning( 'SOME_ERROR_CODE', '<b>'.$row->title.'</b> '.JText::_( 'EDITED BY ANOTHER ADMIN' ));
				$mainframe->redirect( JRoute::_('index.php?option=com_lyftenbloggie&view=entry&id='.$row->id, false) );
			}
		}

		//check if we can edit an entry
		if( !$user->admin ) {
			if( !$user->permission) {
				JError::raiseWarning( 'SOME_ERROR_CODE', JText::_("YOU MUST BE AN AUTHOR TO VIEW THIS RESOURCE"));
				$mainframe->redirect( JRoute::_('index.php?option=com_lyftenbloggie', false) );
			}elseIf($row->created_by != $user->user_id){
				JError::raiseWarning( 'SOME_ERROR_CODE', JText::sprintf('NOT THE AUTHOR', $row->title));
				$mainframe->redirect( JRoute::_('index.php?option=com_lyftenbloggie', false) );
			}
		}

		//add header tags
		$document->addStyleSheet(JURI::base().'/components/com_lyftenbloggie/assets/css/style.css');
		$document->addScript(JURI::base().'/components/com_lyftenbloggie/assets/js/tabber.js');

		//add Java Declaration
		$js = "document.write('<style type=\"text/css\">.tabber{display:none;}<\/style>');";
		$document->addScriptDeclaration($js);
				
		//Get more data from the model
		$lists['catid']   	= & $this->get( 'Categories' );
		$lists['tags']		= & $this->get( 'TagsList' );	
		$lists['created']	= & $this->get( 'Created' );	
		
		// build the html for published		
		$states[] = JHTML::_('select.option',  '1', JText::_( 'PUBLISHED' ) );
		$states[] = JHTML::_('select.option',  '2', JText::_( 'PENDING REVIEW' ) );
		$states[] = JHTML::_('select.option',  '-1', JText::_( 'UNPUBLISHED' ) );
		$states[] = JHTML::_('select.option',  '3', JText::_( 'PENDING DELETION' ) );		
		if (!$user->allowpub) {
			$disabled 	= ' disabled="true"';
			$row->state = 2;
		}
		$lists['state'] = JHTML::_('select.genericlist', $states, 'state', 'class="inputbox" size="1"'.$disabled.'', 'value', 'text', $row->state );

		// build the html for access		
		$access[] = JHTML::_('select.option',  '0', JText::_( 'PUBLIC' ) );
		$access[] = JHTML::_('select.option',  '1', JText::_( 'REGISTERED' ) );
		$access[] = JHTML::_('select.option',  '2', JText::_( 'SPECIAL' ) );
		$lists['access'] = JHTML::_('select.genericlist', $access, 'access', 'class="inputbox" size="1"', 'value', 'text', $row->access );

		// Create the form
		$form = new JParameter('', JPATH_COMPONENT_ADMINISTRATOR.DS.'models'.DS.'entry.xml');
		
		// Advanced Group
		$form->loadINI($row->attribs);
		$form->loadINI($row->metadata);
		
		// Enabled/Disabled
		$enabled[] = JHTML::_('select.option',  '0', JText::_( 'DISABLED' ) );
		$enabled[] = JHTML::_('select.option',  '1', JText::_( 'ENABLED' ) );

		$lists['comments'] 		= JHTML::_('select.genericlist', $enabled, 'params[allow_comments]', 'class="inputbox" size="1"', 'value', 'text', $form->get('allow_comments') );
		$lists['ratings'] 		= JHTML::_('select.genericlist', $enabled, 'params[show_vote]', 'class="inputbox" size="1"', 'value', 'text', $form->get('show_vote') );
		$lists['hits'] 			= JHTML::_('select.genericlist', $enabled, 'params[show_hits]', 'class="inputbox" size="1"', 'value', 'text', $form->get('show_hits') );
		$lists['favourites'] 	= JHTML::_('select.genericlist', $enabled, 'params[show_favourites]', 'class="inputbox" size="1"', 'value', 'text', $form->get('show_favourites') );

		// Make trackback list
		if($row->pinged) {
			$pinged 		= trim($row->pinged);
			$row->pinged 	= explode("\n", $pinged);
		}
		
		//Load the Editor
		$editor =& JFactory::getEditor(); 
		
		//Build the page title string
		$title = $row->id ? JText::_('EDIT') : JText::_('NEW');
		
		//Set page title
		$document->setTitle($title);

		//get pathway
		$pathway =& $mainframe->getPathWay();
		$pathway->addItem($title, '');

		// Unify the introtext and fulltext fields and separated the fields by the readmore tag
		if (JString::strlen($row->fulltext) > 1) {
			$row->text = $row->introtext."<hr id=\"system-readmore\" />".$row->fulltext;
		} else {
			$row->text = $row->introtext;
		}

		//Ensure the row data is safe html
		JFilterOutput::objectHTMLSafe( $row );
		$this->assign('action'				, $uri->toString());
		$this->assignRef('pane'				, $pane);
		$this->assignRef('form'				, $form);
		$this->assignRef('nullDate'			, $nullDate);		
		$this->assignRef('row'				, $row);
		$this->assignRef('params'			, $params);
		$this->assignRef('lists'			, $lists);
		$this->assignRef('editor'			, $editor);
		
		parent::display($tpl);
	}
}
?>