<?php
/**
 * LyftenBloggie 1.0 - Joomla! Blog Manager
 * @package LyftenBloggie 1.0
 * @copyright (C) 2009 Lyften Designs
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.lyften.com/ Official website
 **/
 
// Disallow direct access to this file
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view');

class LyftenBloggieViewMyDetails extends JView {

	function display($tpl = null)
	{
		global $mainframe;

		//initialise variables
		$document 	= & JFactory::getDocument();		
		$user 		= & JFactory::getUser();
		$uri     	=& JFactory::getURI();
		$params 	= & $mainframe->getParams('com_lyftenbloggie', '0');
		$avatarUsed	= $params->get('avatarUsed');
		
		//Make sure user is logged it
		if (($user->guest))
		{
			$return		= $uri->toString();
			$url  		= 'index.php?option=com_user&view=login&return='.base64_encode($return);
			$mainframe->redirect($url, JText::_('PLEASE LOGIN TO EDIT YOUR DETAILS') );
		}
		
		//Load route helper
		require_once (JPATH_SITE.DS.'components'.DS.'com_lyftenbloggie'.DS.'helpers'.DS.'route.php');

		//Get data from the model
		$model			= & $this->getModel();
		$row     		= & $this->get( 'Author' );
		$aboutbox   	= & $this->get( 'AboutBox' );
	
		//Make sure author is there
		if (($row->id == 0))
		{
				JError::raiseWarning( 'SOME_ERROR_CODE', JText::_( 'YOU MUST BE AN AUTHOR TO VIEW THIS RESOURCE' ));
				$mainframe->redirect( 'index.php?option=com_lyftenbloggie' );
		}
		
		//fail if checked out not by 'me'
		if ($row->id) {
			if ($model->isCheckedOut( $user->get('id') )) {
				JError::raiseWarning( 'SOME_ERROR_CODE', '<b>'.$row->name.'</b> '.JText::_( 'EDITED BY ANOTHER ADMIN' ));
				$mainframe->redirect( 'index.php?option=com_lyftenbloggie' );
			}
		}

		//Set theme
		LDHTML::setTheme();
		
		// Create the form
		$form = new JParameter('', JPATH_COMPONENT_ADMINISTRATOR.DS.'models'.DS.'aboutblock.xml');
		$form->loadINI($row->attribs);

		//pathway
		$pathway 	= & $mainframe->getPathWay();
		$pathway->addItem( JText::_('MY DETAILS'));
		
		//assign vars to view
		JFilterOutput::objectHTMLSafe( $row );
		
		$this->assign('action'			, $uri->toString());		
		$this->assignRef('aboutbox'    	, $aboutbox);
		$this->assignRef('form'      	, $form);
		$this->assignRef('users'      	, $users);
		$this->assignRef('row'      	, $row);
		$this->assignRef('avatarUsed'  	, $avatarUsed);

		parent::display($tpl);
	}
}
?>