<?php
/**
 * LyftenBloggie 1.0 - Joomla! Blog Manager
 * @package LyftenBloggie 1.0
 * @copyright (C) 2009 Lyften Designs
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.lyften.com/ Official website
 **/
 
// Disallow direct access to this file
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view');

/**
 * @package Joomla
 * @subpackage LyftenBloggie
 * @since 1.0
 */
class LyftenBloggieViewMyEntries extends JView
{
	/**
	 * Creates the comments page
	 **/
	function display( $tpl = null )
	{
		global $mainframe;

		//initialize variables
		$document 	= & JFactory::getDocument();
		$user		= & JFactory::getUser();
		$menus		= & JSite::getMenu();
		$menu    	= $menus->getActive();
		$dispatcher = & JDispatcher::getInstance();
		$params 	= & $mainframe->getParams('com_lyftenbloggie');
		$uri     	=& JFactory::getURI();
		
		//Make sure user is logged it
		if (($user->guest))
		{
			$return		= $uri->toString();
			$url  		= 'index.php?option=com_user&view=login&return='.base64_encode($return);
			$mainframe->redirect($url, JText::_('PLEASE LOGIN TO EDIT YOUR ENTRIES') );
		}
		
		//Load route helper
		require_once (JPATH_SITE.DS.'components'.DS.'com_lyftenbloggie'.DS.'helpers'.DS.'route.php');

		$limitstart	= JRequest::getVar('limitstart', 0, '', 'int');

		if($this->getLayout() == 'form') {
			$this->_displayForm($tpl);
			return;
		}

		//Set theme
		LDHTML::setTheme();

		$authordetails	= & $this->get('AuthorDetails');

		//Make sure entry is there
		if (empty($authordetails))
		{	
			JError::raiseWarning( 'SOME_ERROR_CODE', JText::_( 'YOU MUST BE AN AUTHOR TO VIEW THIS RESOURCE' ));
			$mainframe->redirect( 'index.php?option=com_lyftenbloggie' );
		}
		
		$entries		= & $this->get('MyEntries');
		$totalentries	= & $this->get('Total');
		$pageNav 		= & $this->get( 'Pagination' );

		//add Java Declaration
		$js = "var url = \"".JURI::base()."index.php?option=com_lyftenbloggie\";

php.messages.errormsg = function (msg, params){
	alert (msg);
}

function deleteentry(entryid){

	if(confirm('Are you sure you want to delete this blog entry?')) {
		jQuery.php(url,{'option':'com_lyftenbloggie', '".JUtility::getToken()."':'1', 'task':'remove', 'id':entryid });
	}
	return false;
}";
		
		$document->addScriptDeclaration($js);
		
		/*
		 * Create the document title
		 **/
		$document->setTitle($authordetails->name.' - '.JText::_('ENTRIES'));
		
		//pathway
		$pathway 	= & $mainframe->getPathWay();
		$pathway->addItem( $this->escape($authordetails->name.' - '.JText::_('ENTRIES')) );

		//assign variables to template
		$this->assignRef('entries' , 		$entries);
		$this->assignRef('totalentries' , 	$totalentries);
		$this->assignRef('pageNav' ,		$pageNav);
		$this->assignRef('authorname' , 	$authordetails->name);
		$this->assignRef('lists' , 			$lists);
		
		parent::display($tpl);

	}
}
?>